#include <stdio.h>
#include <math.h>
#include "main.h"
#include "Camera.h"
#include "Game.h"
#include "Player.h"
#include "KeyPadInput.h"

// \̎̒`
static CAMERA Camera;

// QƗp
CAMERA GetCamera(void){ return Camera; } // J̑S擾
ROT GetCameraRot(void){ return Camera.Rot; } // J̊px擾

// J̏
void CameraInit(void){

	// lIDƈʒu擾
	int ID=GetMainPlayerID();
	VECTOR PlayerPos=GetPlayerPos(ID);

	// _px
	Camera.Rot=GetPlayerRot(ID);
	Camera.RotTar=Camera.Rot;

	// 񔼌a
	Camera.Radius=300.0f;

	// W
	Camera.Pos.x = PlayerPos.x-(Camera.Radius*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Camera.Rot.h))+(100.0f*sin(Camera.Rot.v)*sin(Camera.Rot.h));
	Camera.Pos.z = PlayerPos.z-(Camera.Radius*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Camera.Rot.h))+(100.0f*sin(Camera.Rot.v)*cos(Camera.Rot.h));
	Camera.Pos.y = PlayerPos.y-(Camera.Radius*cos(Camera.Rot.v+1.0f/2.0f*DX_PI))+100.0f*cos(Camera.Rot.v);

	// ]x(1/100)
	Camera.Spd.v=0;
	Camera.Spd.h=0;
	Camera.Spd.t=0;

	// Jf
	SetupCamera_Perspective(DX_PI/3);
	SetCameraPositionAndAngle(Camera.Pos,Camera.Rot.v,Camera.Rot.h,Camera.Rot.t);
}

// Jړ
void CameraControl(void){

	// ͏擾
	KEYCON KeyCon=GetKeyCon();
	KEYCON PadCon=GetPadCon();
	DINPUT_JOYSTATE PadState=GetPadState();

	// J̉Eړ
	if(PadCon.Right2==22&&PadState.Rx>0) Camera.Spd.h=PadState.Rx/100.0f;
	else{
		if(KeyOrPad(CF_RIGHT2)) Camera.Spd.h++; else if(Camera.Spd.h>0) Camera.Spd.h--;
	}

	// J̍ړ
	if(PadCon.Left2==23&&PadState.Rx<0) Camera.Spd.h=PadState.Rx/100.0f;
	else{
		if(KeyOrPad(CF_LEFT2)) Camera.Spd.h--; else if(Camera.Spd.h<0) Camera.Spd.h++;
	}

	// J̏ړ
	if(PadCon.Up2==25&&PadState.Ry<0) Camera.Spd.v=PadState.Ry/100.0f;
	else{
		if(KeyOrPad(CF_UP2)) Camera.Spd.v--; else if(Camera.Spd.v<0) Camera.Spd.v++;
	}

	// J̉ړ
	if(PadCon.Down2==24&&PadState.Ry>0) Camera.Spd.v=PadState.Ry/100.0f; 
	else{
		if(KeyOrPad(CF_DOWN2)) Camera.Spd.v++; else if(Camera.Spd.v>0) Camera.Spd.v--;
	}

	// ̂0ƌȂ
	if(Camera.Spd.v>-1.0f&&1.0f>Camera.Spd.v) Camera.Spd.v=0;
	if(Camera.Spd.h>-1.0f&&1.0f>Camera.Spd.h) Camera.Spd.h=0;
}

// Jړ
void CameraMove(void){
	static VECTOR Pos;

	// lIDƈʒu擾
	int ID=GetMainPlayerID();
	PC MainPlayer=GetPlayer(ID);

	// Q[擾
	int GameFrame=GetGameFrame();
	int GameFunctionStatus=GetGameFunctionStatus();
	int GameSelectedMenu=GetGameSelectedMenu();

	// J̒S_̃Zbg
	if(GameFunctionStatus==FS_PLAY) SetCameraScreenCenter(380.0f,270.0f);
	else SetCameraScreenCenter(480.0f,270.0f);

	// xől̒ߑj~
	if(Camera.Spd.h>C_MAXSPEED) Camera.Spd.h=C_MAXSPEED;
	if(Camera.Spd.v>C_MAXSPEED) Camera.Spd.v=C_MAXSPEED;
	if(Camera.Spd.h<-C_MAXSPEED) Camera.Spd.h=-C_MAXSPEED;
	if(Camera.Spd.v<-C_MAXSPEED) Camera.Spd.v=-C_MAXSPEED;

	// px̐ݒ
	// Free[hȂ
	if(MainPlayer.Flag.TargetMode==AIM_FREE){
		Camera.RotTar.h+=(1.0f/2.0f)*DX_PI*(double)Camera.Spd.h/300.0f;
		Camera.RotTar.v-=(1.0f/2.0f)*DX_PI*(double)Camera.Spd.v/600.0f;

	// Target[hȂ
	}else{
		Camera.RotTar.h=MainPlayer.RotTar.h;
		Camera.RotTar.v=MainPlayer.RotTar.v;
	}

	// S̃J[N
	if(GameFunctionStatus==FS_PLAY&&MainPlayer.State==PS_DEAD&&GameFrame-MainPlayer.Flag.LastDeadFrame<20){
		if(GameFrame-MainPlayer.Flag.LastDeadFrame==1){
			Pos=MainPlayer.Pos;
			Camera.RotTar.v=0.8;
		}
		Camera.Radius+=20;
	}else if(MainPlayer.State==PS_DEAD&&GameFrame-MainPlayer.Flag.LastDeadFrame>=20) goto A;

		// ĨJ[N
	if(GameFunctionStatus==FS_RESULT){
		Camera.Spd.h=0.5;
		Camera.Spd.v=0;
		MainPlayer.Flag.TargetMode=0;
		Camera.RotTar.h+=(1.0f/2.0f)*DX_PI*(double)Camera.Spd.h/300.0f;
		Camera.RotTar.v-=(1.0f/2.0f)*DX_PI*(double)Camera.Spd.v/600.0f;
	}

	// }bvIʂ̃J[N
	if(GameSelectedMenu==SM_MAP&&GameFunctionStatus==FS_MENU){
		Camera.Spd.h=0.5;
		Camera.Rot.v=0.4;
		Camera.RotTar.v=0.4;
		Camera.Radius=3000;
		Camera.RotTar.h+=(1.0f/2.0f)*DX_PI*(double)Camera.Spd.h/300.0f;
		Camera.RotTar.v-=(1.0f/2.0f)*DX_PI*(double)Camera.Spd.v/600.0f;
	}

	// }X^[Xp[Nˎ̃J[N
	if(GameFunctionStatus==FS_PLAY&&MainPlayer.SetBomb.Selected==BM_MASTERSPARK&&MainPlayer.SetBomb.State==SS_ACTIVATED){			
		if(GameFrame-MainPlayer.SetBomb.StartFrame==0){
			Camera.RotTar.h=MainPlayer.SARot.h+0.3;
			Camera.RotTar.v=MainPlayer.SARot.v+0.1;
		}
		if(MainPlayer.SetBomb.EndFrame-GameFrame==19){
			Camera.RotTar.h=MainPlayer.SARot.h+0.3;
			Camera.RotTar.v=MainPlayer.SARot.v-0.1;
		}
	}

	// őp̒ߖh~
	if(Camera.RotTar.v-(1.0f/2.0f)*DX_PI*(double)Camera.Spd.v/100.0f<-1.4f) Camera.RotTar.v=-1.4f;
	if(1.4f<Camera.RotTar.v-(1.0f/2.0f)*DX_PI*(double)Camera.Spd.v/100.0f) Camera.RotTar.v=1.4f;
	if(Camera.Rot.h>2.0f*DX_PI) Camera.Rot.h-=2.0f*DX_PI;
	if(Camera.Rot.h<0) Camera.Rot.h+=2.0f*DX_PI;
	if(Camera.RotTar.h>2.0f*DX_PI) Camera.RotTar.h-=2.0f*DX_PI;
	if(Camera.RotTar.h<0) Camera.RotTar.h+=2.0f*DX_PI;

	// ڕWlɋ߂Â
	if(Camera.RotTar.h-Camera.Rot.h>DX_PI) Camera.Rot.h-=0.05f;
	else if(Camera.RotTar.h-Camera.Rot.h>0.025f) Camera.Rot.h+=0.05f;
	else if(Camera.RotTar.h-Camera.Rot.h>-0.025f) Camera.Rot.h=Camera.RotTar.h; 
	else if(Camera.RotTar.h-Camera.Rot.h>-DX_PI) Camera.Rot.h-=0.05f;
	else Camera.Rot.h+=0.05f;
	if(sqrt(pow(Camera.Rot.v-Camera.RotTar.v,2))<=0.05f) Camera.Rot.v=Camera.RotTar.v; else if(Camera.Rot.v<Camera.RotTar.v) Camera.Rot.v+=0.05f; else if(Camera.Rot.v>Camera.RotTar.v) Camera.Rot.v-=0.05f;
	if(sqrt(pow(Camera.Rot.t-Camera.RotTar.t,2))<=0.05f) Camera.Rot.t=Camera.RotTar.t; else if(Camera.Rot.t<Camera.RotTar.t) Camera.Rot.t+=0.05f; else if(Camera.Rot.t>Camera.RotTar.t) Camera.Rot.t-=0.05f;

	// lʒuݒ
	Camera.Pos.x = MainPlayer.Pos.x-(Camera.Radius*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Camera.Rot.h))+(100.0f*sin(Camera.Rot.v)*sin(Camera.Rot.h));
	Camera.Pos.z = MainPlayer.Pos.z-(Camera.Radius*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Camera.Rot.h))+(100.0f*sin(Camera.Rot.v)*cos(Camera.Rot.h));
	Camera.Pos.y = MainPlayer.Pos.y-(Camera.Radius*cos(Camera.Rot.v+1.0f/2.0f*DX_PI))+100.0f*cos(Camera.Rot.v);

	// lʒuݒiS
	if(GameFunctionStatus==FS_PLAY&&MainPlayer.State==PS_DEAD&&GameFrame-MainPlayer.Flag.LastDeadFrame<20){
		Camera.Pos.x = Pos.x-(Camera.Radius*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*cos(1.0f/2.0f*DX_PI-Camera.Rot.h))+(100.0f*sin(Camera.Rot.v)*sin(Camera.Rot.h));
		Camera.Pos.z = Pos.z-(Camera.Radius*sin(Camera.Rot.v+1.0f/2.0f*DX_PI)*sin(1.0f/2.0f*DX_PI-Camera.Rot.h))+(100.0f*sin(Camera.Rot.v)*cos(Camera.Rot.h));
		Camera.Pos.y = Pos.y-(Camera.Radius*cos(Camera.Rot.v+1.0f/2.0f*DX_PI))+100.0f*cos(Camera.Rot.v);
	}

	// _[W\
	if(GameFunctionStatus==FS_PLAY&&GameFrame-MainPlayer.Flag.LastDamageFrame<10){
		Camera.Rot.h+=(GetRand(10-GameFrame+MainPlayer.Flag.LastDamageFrame)-10+GameFrame-MainPlayer.Flag.LastDamageFrame)/100.0;
		Camera.Rot.v+=(GetRand(10-GameFrame+MainPlayer.Flag.LastDamageFrame)-10+GameFrame-MainPlayer.Flag.LastDamageFrame)/100.0;
	}

	// }X^[Xp[N̐U
	if(GameFunctionStatus==FS_PLAY&&MainPlayer.SetBomb.Selected==BM_MASTERSPARK&&MainPlayer.SetBomb.State==SS_ACTIVATED){
		if(GameFrame-MainPlayer.SetBomb.StartFrame>100){
			Camera.Rot.h+=(GetRand(10)-10)/1000.0;
			Camera.Rot.v+=(GetRand(10)-10)/1000.0;
		}
	}

	// Jf
	A:
	SetCameraPositionAndAngle(VGet(Camera.Pos.x,Camera.Pos.y,Camera.Pos.z),Camera.Rot.v,Camera.Rot.h,Camera.Rot.t) ;
}