#include <stdio.h>
#include <string.h>
#include <math.h>
#include "DxLib.h"

#include "Direction.h"
#include "main.h"
#include "Game.h"
#include "Player.h"
#include "Camera.h"
#include "Bullet.h"
#include "KillLog.h"
#include "Map.h"
#include "Num.h"
#include "KeyPadInput.h"
#include "Font.h"
#include "GraphHandle.h"
#include "Shader.h"
#include "Team.h"

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int){

    // 
	InitPhase();

	// [v
    while(ScreenFlip()==0&&ProcessMessage()==0&&ClearDrawScreen()==0){

		// L[͏Ԃ擾
		GetHitKeyStateAll2();

		// pbh͏Ԃ擾
		GetHitPadStateAll();

		switch(GetGameFunctionStatus()){

			// j
			case FS_MENU:
				switch(GetGameSelectedMenu()){
				case SM_NOTSELECTED:
					Menu();            // j
					break;
				case SM_KEYCONFIG:
					KeyConfig();       // L[R
					break;
				case SM_RULE:
					RuleSelect();      // [I
					break;
				case SM_MAP:
					MapSelect();       // }bvI
					break;
				case SM_CHARACTER:
					CharacterSelect(); // LI
					break;
				case SM_START:
					StartSelect();
					PlayInit();		   // Q[
					break;
				}
				MovePhase();	       // ړtF[Y
				MenuDraw();            // j`
				break;

			// Q[{
			case FS_PLAY:
				if(GetGameFrame()>=1000){
					CalcPhase();       // vZtF[Y
					ControlPhase();    // tF[Y
					MovePhase();	   // ړtF[Y
					StageGimmick();    // Xe[W̎d|
					LastTask();        // ^[̍Ōɂd
				}
				DrawPhase();           // `tF[Y
				DeadDirection();
				GameDirection();       // Q[Jno
				break;

			// ʕ\
			case FS_RESULT:
				MovePhase();		   // ړtF[Y
				DrawPhase();           // `tF[Y
				ResultDirection();     // ʉʉo
				break;
		}
		GameFrameCountUp();            // Q[ԉZ
	}

	DxLib_End(); // ㏈
	return 0;
}

// 
void InitPhase(void){

	// ݒ
	SetGraphMode(WINDOWWIDTH,WINDOWHEIGHT,COLORBIT,REFRESHRATE);
	ChangeWindowMode(TRUE), DxLib_Init(), SetDrawScreen(DX_SCREEN_BACK);

	// tHg̓o^
	FontRegist();

	// yobt@ւ݂̏Lɂ
	SetUseZBuffer3D(TRUE);
	SetWriteZBuffer3D(TRUE);

	// f̓ǂݍ
	LoadCharacterModel();
	LoadBombModel();
	LoadMapModel();

	// sNZVF[_oCiR[h̓ǂݍ
	LoadShader();

	// 摜̓ǂݍ
	LoadGraphs();

	// L[擾
	LoadKeyName();

	// ݒ菉
	KeyConfigInit();

	// gQ[tO
	GameInit();
}

// Q[̏
void PlayInit(void){

	// 
	PlayerInit();
	CameraInit();
	NumInit();

	// `[̏
	TeamInit();
}

// vZn
void CalcPhase(void){
	
	// ĽԂvZ
	CalcPlayer();
}

// n
void ControlPhase(void){
	
	// L̑
	MainPlayerControl(); // vC[̑
	CpuControl();        // CPȖ

	// J̑
	CameraControl();
}

// ړn
void MovePhase(void){

	// L̈ړ
	MainPlayerMove(); // vCL
	CpuMove();        // CPUL

	// ëړ
	BulletMove(); // ʏe
	SkillMove();  // XLe
	BombMove();   // {e

	// J̈ړ
	CameraMove();
}

// `ʌn
void DrawPhase(void){

	DrawPlayer();       // L`

	DrawBullet();       // e`

	DrawMap();          // }bv`
	DrawEnemyStatus();  // G̏Ԃ`
	DrawPlayerStatus(); // ̏Ԃ`
}

// ^[̏Iɂd
void LastTask(void){

	// L̍XV
	UpdateAllPlayer();

	UpdateBulletAnim();

	// Q[I
	if(CheckTeamWin()!=-1) UpdateGameFunctionStatus(FS_RESULT);

	// LO̐
	KillLogUnregistAsNecessary();
	UpdateKillLog();
}