#include "DxLib.h"
#include "Direction.h"
#include "Draw.h"
#include "Move.h"
#include "main.h"
#include <math.h>

extern SHADER Shader;
extern PC Pc[PCNUM];
extern CAMERA Camera;
extern TEAM Team[PCNUM];
extern GRAPHHANDLE Handle;
extern KILLLOG KillLog[6];
extern NUM Num;
extern GAME Game;
extern FONT Font;
extern int PlayerID;

// LO
void UpdateKillLog(void){
	for(int i=0;i<Num.KillLog;i++){
		KillLog[i].Nx=10;
		KillLog[i].Ny=400+28*i;

		if(KillLog[i].y>KillLog[i].Ny) KillLog[i].y-=4;
	}
}

// So
void DeadDirection(void){

	// X|[JEg_E`
	if(Pc[PlayerID].State==PS_DEAD){
		if(Game.Frame-Pc[PlayerID].Flag.LastDeadFrame>120){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-Pc[PlayerID].Flag.LastDeadFrame-120)*255/60);
			DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"1");
		}else if(Game.Frame-Pc[PlayerID].Flag.LastDeadFrame>60){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-Pc[PlayerID].Flag.LastDeadFrame-60)*255/60);
			DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"2");
		}else if(Game.Frame-Pc[PlayerID].Flag.LastDeadFrame>0){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-Pc[PlayerID].Flag.LastDeadFrame-0)*255/60);
			DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"3");
		}
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}
}

// ʕ\o
void ResultDirection(void){
	
	// gtF[hC
	if(Game.Frame<50){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,255.0-Game.Frame*255.0/50.0);
		DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}

	// gtF[hAEg
	if(Game.Frame>950){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-950.0)*255.0/50.0);
		DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}

	// ȉAΐ팋ʕ\
	double BoxAlpha,BoxFade;

	// xAtF[hlXV
	if(Game.Frame<100) BoxAlpha=0.0;
	else if(Game.Frame<125) BoxAlpha=(Game.Frame-100.0)*8.0;
	else if(Game.Frame<900) BoxAlpha=200.0;
	else if(Game.Frame<925) BoxAlpha=(200.0-(Game.Frame-900.0)*8.0);
	else BoxAlpha=0.0;
	if(Game.Frame<100) BoxFade=-100.0;
	else if(Game.Frame<112) BoxFade=-100.0+(Game.Frame-100.0)*8.0;
	else if(Game.Frame<930) BoxFade=0;
	else if(Game.Frame<942) BoxFade=32.0+(Game.Frame-700.0)*8.0;
	else BoxFade=100.0;

	SetDrawBlendMode(DX_BLENDMODE_ALPHA,BoxAlpha);
	DrawBox(50.0+BoxFade,30,WINDOWWIDTH-50.0+BoxFade,510,GetColor(0,0,0),1);
	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

	// ΐ탋[\
	int RuleAlpha = (Game.Frame - 100)*2;
	if(Game.SelectedRule==SR_TEAMDEATHMATCH){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha));
		DrawFormatStringToHandle(70+BoxFade,50,GetColor(255,255,255),Font.Rule,"TeamDeathMatch");
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-30));
		DrawFormatStringToHandle(70+BoxFade,90,GetColor(255,255,255),Font.KeyConfig,"F`[75l|");

		// `[\
		if(Team[0].Win==1){
			DrawFormatStringToHandle(80+BoxFade,130,GetColor(255,255,64),Font.Status,"WON");
		}else{
			DrawFormatStringToHandle(480+BoxFade,130,GetColor(255,255,64),Font.Status,"WON");
		}

		// `[_\
		DrawBox(90+BoxFade,170,450+BoxFade,190,GetColor(255,64,64),1);
		DrawFormatStringToHandle(80+BoxFade,160,GetColor(255,255,255),Font.Status,"RED TEAM");
		DrawFormatStringToHandle(380+BoxFade,140,GetColor(255,255,255),Font.Rule,"%2d",Team[0].Point);
		DrawBox(490+BoxFade,170,850+BoxFade,190,GetColor(64,64,255),1);
		DrawFormatStringToHandle(480+BoxFade,160,GetColor(255,255,255),Font.Status,"BLUE TEAM");
		DrawFormatStringToHandle(780+BoxFade,140,GetColor(255,255,255),Font.Rule,"%2d",Team[1].Point);
		
	}

	// lѕ\
	int FIndex=0,EIndex=0;
	for(int i=0;i<PCNUM;i++){
		if(Pc[i].Team==0){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-10*i-50));
			DrawFormatStringToHandle(80+BoxFade,210+35*FIndex,GetColor(255,255,255),Font.KeyConfig,"%s",Pc[i].Name);
			DrawFormatStringToHandle(150+BoxFade,210+35*FIndex,GetColor(255,255,255),Font.KeyConfig,"Won:%2d  Lost:%2d  _:%6d",Pc[i].Kill,Pc[i].Death,Pc[i].Score);
			FIndex++;
		}else{
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-10*i-50));
			DrawFormatStringToHandle(480+BoxFade,210+35*EIndex,GetColor(255,255,255),Font.KeyConfig,"%s",Pc[i].Name);
			DrawFormatStringToHandle(550+BoxFade,210+35*EIndex,GetColor(255,255,255),Font.KeyConfig,"Won:%2d  Lost:%2d  _:%6d",Pc[i].Kill,Pc[i].Death,Pc[i].Score);
			EIndex++;
		}
	}

	// 1000t[oߌAj[ɖ߂
	if(Game.Frame==1000){
		Game.FunctionStatus=FS_MENU;
		Game.Frame=-1;
	}

	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
}

// Q[Jn̉o
void GameDirection(void){

	static VERTEX2DSHADER Vert[6];
	
	// Q[Jn
	if(Game.Frame==0){

		// `ʉ\ȉ摜쐬
		SetUseDivGraphFlag(FALSE);
		SetDrawValidAlphaChannelGraphCreateFlag(TRUE);
		Handle.Screen.Graph=MakeScreen(961,541,0);
		SetDrawValidAlphaChannelGraphCreateFlag(FALSE);
		SetUseDivGraphFlag(TRUE);

		// _f[^̏
		Vert[ 0 ].pos = VGet(   0.0f,   0.0f, 0.0f ) ;
		Vert[ 1 ].pos = VGet( 960.0f,   0.0f, 0.0f ) ;
		Vert[ 2 ].pos = VGet(   0.0f, 540.0f, 0.0f ) ;
		Vert[ 3 ].pos = VGet( 960.0f, 540.0f, 0.0f ) ;
		Vert[ 0 ].dif = GetColorU8( 255,255,255,255 ) ;
		Vert[ 0 ].spc = GetColorU8( 0,0,0,0 ) ;
		Vert[ 1 ].dif = GetColorU8( 255,255,255,255 ) ;
		Vert[ 1 ].spc = GetColorU8( 0,0,0,0 ) ;
		Vert[ 2 ].dif = GetColorU8( 255,255,255,255 ) ;
		Vert[ 2 ].spc = GetColorU8( 0,0,0,0 ) ;
		Vert[ 3 ].dif = GetColorU8( 255,255,255,255 ) ;
		Vert[ 3 ].spc = GetColorU8( 0,0,0,0 ) ;
		Vert[ 0 ].u = 0.0f ; Vert[ 0 ].v = 0.0f ;
		Vert[ 1 ].u = 1.0f ; Vert[ 1 ].v = 0.0f ;
		Vert[ 2 ].u = 0.0f ; Vert[ 2 ].v = 1.0f ;
		Vert[ 3 ].u = 1.0f ; Vert[ 3 ].v = 1.0f ;
		Vert[ 0 ].su = 0.0f ; Vert[ 0 ].sv = 0.0f ;
		Vert[ 1 ].su = 1.0f ; Vert[ 1 ].sv = 0.0f ;
		Vert[ 2 ].su = 0.0f ; Vert[ 2 ].sv = 1.0f ;
		Vert[ 3 ].su = 1.0f ; Vert[ 3 ].sv = 1.0f ;
		Vert[ 0 ].rhw = 1.0f ;
		Vert[ 1 ].rhw = 1.0f ;
		Vert[ 2 ].rhw = 1.0f ;
		Vert[ 3 ].rhw = 1.0f ;
		Vert[ 4 ] = Vert[ 2 ] ;
		Vert[ 5 ] = Vert[ 1 ] ;
	}
	
	// O[XP[摜ĕ`
	SetDrawScreen(Handle.Screen.Graph);
	ClearDrawScreen();

	// JĐݒ
	SetupCamera_Perspective(M_PI/3);
	SetCameraScreenCenter(380.0f,270.0f);
	SetCameraPositionAndAngle(VGet(Camera.Pos.x,Camera.Pos.y,Camera.Pos.z),Camera.Rot.v,Camera.Rot.h,Camera.Rot.t) ;
	
	BulletDraw();                      // e`
	MapDraw();                         // }bv`
	PcDraw();                          // LN^`
	OtherDraw();                       // ɕ`ʂ̂΁B
	DrawStatus();                      // G̏Ԃ`
	DrawPStatus();                     // ̏Ԃ`	
	
	SetDrawScreen(DX_SCREEN_BACK);

	// JĐݒ
	SetupCamera_Perspective(M_PI/3);
	SetCameraScreenCenter(380.0f,270.0f);
	SetCameraPositionAndAngle(VGet(Camera.Pos.x,Camera.Pos.y,Camera.Pos.z),Camera.Rot.v,Camera.Rot.h,Camera.Rot.t);
	
	// gpeNX`Zbg
	SetUseTextureToShader(0, Handle.Screen.Graph);
	
	// gpsNZVF[_Zbg
	SetUsePixelShader(Shader.Gray);

	// VF[_ɒ萔Zbg
	int cindex = GetConstIndexToShader("Alpha", Shader.Gray);
	float alpha;
	alpha=((float)(900.0f-Game.Frame)/255.0f);
	FLOAT4 Alpha = {1.0f, 1.0f, 1.0f, alpha};
    SetPSConstF(cindex, Alpha);

	// `
	SetDrawBlendMode(DX_BLENDMODE_ALPHA,0);
	DrawPrimitive2DToShader( Vert, 6, DX_PRIMTYPE_TRIANGLELIST );
	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

	// tF[hCo
	if(Game.Frame<50){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,255.0-Game.Frame*255.0/50.0);
		DrawBox(0,0,WINDOWWIDTH,WINDOWHEIGHT,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
	}

	// ȉAΐJ[h\
	double BoxAlpha,BoxFade;

	// xAtF[hlXV
	if(Game.Frame<100) BoxAlpha=0.0;
	else if(Game.Frame<125) BoxAlpha=(Game.Frame-100.0)*8.0;
	else if(Game.Frame<700) BoxAlpha=200.0f;
	else if(Game.Frame<708) BoxAlpha=(200.0f-(Game.Frame-700.0)*32.0);
	else BoxAlpha=0.0f;
	if(Game.Frame<100) BoxFade=-100.0f;
	else if(Game.Frame<108) BoxFade=-100.0+(Game.Frame-100.0)*8.0;
	else if(Game.Frame<700) BoxFade=-32.0+(Game.Frame-110.0)*64.0/700.0;
	else if(Game.Frame<708) BoxFade=32.0+(Game.Frame-700.0)*8.0;
	else BoxFade=100.0f;

	SetDrawBlendMode(DX_BLENDMODE_ALPHA,BoxAlpha);
	DrawBox(50.0f+BoxFade,30,710.0f+BoxFade,510,GetColor(0,0,0),1);
	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);

	// ΐ탋[\
	int RuleAlpha = (Game.Frame - 100)*2;
	if(Game.SelectedRule==SR_TEAMDEATHMATCH){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha));
		DrawFormatStringToHandle(70+BoxFade,50,GetColor(255,255,255),Font.Rule,"TeamDeathMatch");
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-30));
		DrawFormatStringToHandle(70+BoxFade,90,GetColor(255,255,255),Font.KeyConfig,"F`[75̓|");

		DrawBox(90+BoxFade,140,370+BoxFade,160,GetColor(255,64,64),1);
		DrawFormatStringToHandle(80+BoxFade,130,GetColor(255,255,255),Font.Status,"RED TEAM");
		DrawBox(410+BoxFade,140,690+BoxFade,160,GetColor(64,64,255),1);
		DrawFormatStringToHandle(400+BoxFade,130,GetColor(255,255,255),Font.Status,"BLUE TEAM");
		
	}

	// L\
	int FIndex=0,EIndex=0;
	for(int i=0;i<PCNUM;i++){
		if(Pc[i].Team==0){
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-10*i-50));
			DrawFormatStringToHandle(80+BoxFade,180+40*FIndex,GetColor(255,255,255),Font.KeyConfig,"%s",Pc[i].Name);
			FIndex++;
		}else{
			SetDrawBlendMode(DX_BLENDMODE_ALPHA,min(BoxAlpha,RuleAlpha-10*i-50));
			DrawFormatStringToHandle(400+BoxFade,180+40*EIndex,GetColor(255,255,255),Font.KeyConfig,"%s",Pc[i].Name);
			EIndex++;
		}
	}

	// 5JEg_E
	if(Game.Frame>940){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-940)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"1");
	}else if(Game.Frame>880){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-880)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"2");
	}else if(Game.Frame>820){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-820)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"3");
	}else if(Game.Frame>760){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-760)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"4");
	}else if(Game.Frame>700){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-700)*255/60);
		DrawFormatStringToHandle(370,250,GetColor(255,255,255),Font.Rule,"5");
	}

	// `[̓_{[h̃tF[hC
	if(Game.Frame>940){
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-940)*255/120);
		DrawBox(250,0,520,50,GetColor(0,0,0),1);
		SetDrawBlendMode(DX_BLENDMODE_ALPHA,(Game.Frame-940)*255/60);
		DrawFormatStringToHandle(270,10,GetColor(255,255,255),Font.Status,"RED: %2d - %2d :BLUE",Team[0].Point,Team[1].Point);
		}

	SetDrawBlendMode(DX_BLENDMODE_NOBLEND,0);
}